SystemOrganization addCategory: #'ProfStef-Tests'!

Trait named: #TTutorialTest
	uses: {}
	category: 'ProfStef-Tests'!

!TTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 2/1/2010 21:57'!
testEachSelectorExists
	self testedTutorial tutorial do: [:aSelector|
		self assert: (self tutorial respondsTo: aSelector) 
	]! !

!TTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 2/1/2010 21:59'!
testEachSelectorReturnsALesson
	| answer |
	self testedTutorial tutorial do: [:aSelector|
		answer := (self testedTutorial perform: aSelector).
		self assert: (answer isKindOf: Lesson).
	]! !

!TTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 2/1/2010 21:59'!
testLessonAtReturnsCorrespondingLesson
	| answer |
	1 to: (self testedTutorial tutorial size) do: [:index|
		answer := self testedTutorial lessonAt: index.
		self assert: (answer isKindOf: Lesson)
	]
	! !

!TTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 2/1/2010 22:00'!
testNotEmpty
	self assert: self testedTutorial tutorial notEmpty.! !

!TTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 2/1/2010 22:00'!
testSizeReturnsNumberOfSelectors
	self assert: (self testedTutorial tutorial size) equals: self testedTutorial size.! !

!TTutorialTest methodsFor: 'requirements' stamp: 'LaurentLaffont 2/1/2010 22:04'!
testedTutorial
	"Returns an instance of an AbstractTutorial subclass"
	^ self explicitRequirement! !

TestCase subclass: #AbstractTutorialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!AbstractTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 9/21/2010 20:32'!
testLessonsReturnsAllLessonInstances
	|lessons|
	lessons := MockTutorial new lessons.
	self assert:3 equals:lessons size.
	self assert: 'first' equals: lessons first title.
	self assert: 'second' equals: (lessons at:2 ) title.
	self assert: 'third' equals: lessons last title.! !

!AbstractTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 1/27/2010 21:05'!
testTitleHumanizeClassName
	self assert: 'How To Make Your Own Tutorial' equals: HowToMakeYourOwnTutorial title.
	self assert: 'Smalltalk Syntax Tutorial' equals: SmalltalkSyntaxTutorial title.! !

!AbstractTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 4/26/2011 12:46'!
testTutorialRaisesShouldBeImplemented
	| tutorial |
	tutorial := AbstractTutorial new.
	self 
		should: [tutorial tutorial]
		raise: Error
		withExceptionDo: [:anException | 
			self 
				assert:  ShouldBeImplemented 
				equals: anException class
		].
	! !

!AbstractTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 1/30/2010 09:36'!
testTutorialsReturnsAllButMockTutorial
	| tutorials |
	tutorials := AbstractTutorial tutorials.
	self assert: (tutorials includes: SmalltalkSyntaxTutorial).
	self assert: (tutorials includes: HowToMakeYourOwnTutorial).
	self deny: (tutorials includes: MockTutorial).! !

TestCase subclass: #HowToMakeYourOwnTutorialTest
	uses: TTutorialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

HowToMakeYourOwnTutorialTest class
	uses: TTutorialTest classTrait
	instanceVariableNames: ''!

!HowToMakeYourOwnTutorialTest methodsFor: 'as yet unclassified' stamp: 'LaurentLaffont 2/1/2010 22:05'!
testEachSelectorExists
	self testedTutorial tutorial do: [:aSelector|
		self assert: (self testedTutorial respondsTo: aSelector) 
	]! !

!HowToMakeYourOwnTutorialTest methodsFor: 'as yet unclassified' stamp: 'LaurentLaffont 2/1/2010 22:04'!
testedTutorial
	"Returns an instance of an AbstractTutorial subclass"
	^ HowToMakeYourOwnTutorial new! !

TestCase subclass: #LessonTestInstanciation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!LessonTestInstanciation methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 15:12'!
testNewLessonHaveEmptyStringForTitleLesson
	| newLesson  |
	newLesson := Lesson new.
	self assert: newLesson title equals: ''.
	self assert: newLesson lesson equals: ''.! !

!LessonTestInstanciation methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 15:10'!
testTitleLessonCreation
	| firstLesson secondLesson |
	firstLesson := Lesson title: 'First lesson' lesson: 'Smalltalk rules!!'.
	secondLesson := Lesson title: 'Second lesson' lesson: 'ProfStef is cool'.
	
	self assert: firstLesson title equals: 'First lesson'.
	self assert: firstLesson lesson equals: 'Smalltalk rules!!'.
	
	self assert: secondLesson title equals: 'Second lesson'.
	self assert: secondLesson lesson equals: 'ProfStef is cool'.! !

TestCase subclass: #ProfStefHelpTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!ProfStefHelpTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2011 16:50'!
testBookName
	self assert: ProfStefHelp bookName isString! !

!ProfStefHelpTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2011 16:53'!
testCreateATutorial
	| helpTopic |
	helpTopic := ProfStefHelp createATutorial.
	self assert: helpTopic notNil.
	self assert: helpTopic class == HelpTopic.
	self assert: helpTopic title = 'Create a tutorial'! !

!ProfStefHelpTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2011 16:54'!
testIntroduction
	| helpTopic |
	helpTopic := ProfStefHelp introduction.
	self assert: helpTopic notNil.
	self assert: helpTopic class == HelpTopic.
	self assert: helpTopic title = 'Introduction'! !

!ProfStefHelpTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2011 16:49'!
testListOfTutorials
	| helpTopic |
	helpTopic  := ProfStefHelp listOfTutorials.
	self assert: (helpTopic notNil).
	self assert: (helpTopic title =  'List of tutorials'  )! !

!ProfStefHelpTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2011 16:51'!
testPages
	self assert: ProfStefHelp pages isCollection.
	self assert: (ProfStefHelp pages allSatisfy: #isSymbol).! !

TestCase subclass: #ProfStefHelpTutorialBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!ProfStefHelpTutorialBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2011 17:13'!
testBuild
	| helpTopic builder tutorial |
	tutorial := ProfStefTutorialsHelp.
	helpTopic := ProfStefHelpTutorialBuilder buildHelpTopicFrom: tutorial.
	self assert: helpTopic notNil! !

!ProfStefHelpTutorialBuilderTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2011 17:00'!
testInstantiation 
	self should: [ ProfStefHelpTutorialBuilder new ] raise: Error! !

TestCase subclass: #ProfStefTestGo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!ProfStefTestGo methodsFor: 'running' stamp: 'LaurentLaffont 1/21/2010 20:53'!
tearDown
	ProfStef default close! !

!ProfStefTestGo methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 21:08'!
testGoOnMockTutorial
	| displayedText expected |
	ProfStef goOn: MockTutorial.
	
	displayedText := ProfStef default lessonView text.
	expected := MockTutorial new firstLesson lesson.
 	self assert: displayedText equals: expected.! !

!ProfStefTestGo methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 21:06'!
testGoOpenSmalltalkSyntaxTutorial
	| displayedText expected |
	ProfStef go.
	
	displayedText := ProfStef default lessonView text.
	expected := SmalltalkSyntaxTutorial new welcome lesson.
 	self assert: displayedText equals: expected.! !

!ProfStefTestGo methodsFor: 'tests' stamp: 'LaurentLaffont 9/18/2011 20:10'!
testGoTwiceShowLessonViewIfNotVisible
	| firstLessonView |
	ProfStef go.
	firstLessonView := ProfStef default lessonView.
	firstLessonView close.
	ProfStef goOn: SmalltalkSyntaxTutorial.
	self assert:  (World systemWindows includes:  firstLessonView window).! !

!ProfStefTestGo methodsFor: 'tests' stamp: 'LaurentLaffont 9/18/2011 20:00'!
testGoTwiceUseSameLessonView
	| firstLessonView |
	ProfStef go.
	firstLessonView := ProfStef default lessonView.
	ProfStef goOn: SmalltalkSyntaxTutorial.
	self assert: (firstLessonView ==  ProfStef default lessonView).! !

TestCase subclass: #ProfStefTestGoOnMockTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!ProfStefTestGoOnMockTutorial methodsFor: 'running' stamp: 'LaurentLaffont 4/26/2011 13:54'!
setUp
	ProfStef tutorial: MockTutorial lesson: #firstLesson ! !

!ProfStefTestGoOnMockTutorial methodsFor: 'running' stamp: 'LaurentLaffont 4/26/2011 13:26'!
tearDown
	ProfStef default close! !

!ProfStefTestGoOnMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 4/26/2011 13:26'!
testFirstLessonShouldBeDisplayed.
 	self assert:  'First lesson' equals: ProfStef default lessonView text! !

!ProfStefTestGoOnMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 4/26/2011 13:34'!
testLastShouldGoToThirdLesson
	ProfStef last.
 	self assert:  'Third lesson' equals: ProfStef default lessonView text! !

!ProfStefTestGoOnMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 4/26/2011 13:35'!
testLastThenFirstShouldGoToFirstLesson
	ProfStef last; first.
 	self assert:  'First lesson' equals: ProfStef default lessonView text! !

!ProfStefTestGoOnMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 4/26/2011 13:35'!
testLastThenPreviousShouldGoToSecondLesson
	ProfStef last; previous.
 	self assert:  'Second lesson' equals: ProfStef default lessonView text! !

!ProfStefTestGoOnMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 4/26/2011 13:33'!
testNextShouldGoToSecondLesson
	ProfStef next.
 	self assert:  'Second lesson' equals: ProfStef default lessonView text! !

TestCase subclass: #ProfStefTestNavigation
	instanceVariableNames: 'prof mockView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!ProfStefTestNavigation methodsFor: 'running' stamp: 'LaurentLaffont 1/21/2010 21:13'!
setUp
	prof := ProfStef new.
	prof player: (
		TutorialPlayer new 
			tutorial: MockTutorial new; 
			yourself).
	mockView := MockLessonView new.
	prof lessonView: mockView.
	prof open.! !

!ProfStefTestNavigation methodsFor: 'tests' stamp: 'LaurentLaffont 2/15/2011 22:13'!
testNextOpenSecondLesson
	prof next.
	self assert: mockView title equals: 'second (2/3)'.
	self assert: mockView lesson lesson equals: 'Second lesson'.! !

!ProfStefTestNavigation methodsFor: 'tests' stamp: 'LaurentLaffont 2/15/2011 22:12'!
testSequenceNextNextOpenThirdLesson
	prof next; next.
	self assert: mockView title equals: 'third (3/3)'.
	self assert: mockView lesson lesson equals: 'Third lesson'.! !

!ProfStefTestNavigation methodsFor: 'tests' stamp: 'LaurentLaffont 2/15/2011 22:11'!
testSequenceNextNextPreviousOpenSecondLesson
	prof next; next; previous.
	self assert: mockView title equals: 'second (2/3)'.
	self assert: mockView lesson lesson equals: 'Second lesson'.! !

!ProfStefTestNavigation methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 16:27'!
testShowFirstLessonOnGo
	| lesson |
	lesson := mockView lesson.
	self assert: lesson title equals: 'first'.
	self assert: lesson lesson equals: 'First lesson'.! !

!ProfStefTestNavigation methodsFor: 'as yet unclassified' stamp: 'LaurentLaffont 2/15/2011 22:12'!
testShowingLessonByIndex
	prof tutorial: MockTutorial lessonAt: 2.
	self assert: mockView title equals: 'second (2/3)'.
	self assert: mockView lesson lesson equals: 'Second lesson'.! !

!ProfStefTestNavigation methodsFor: 'as yet unclassified' stamp: 'LaurentLaffont 2/15/2011 22:12'!
testShowingLessonBySelector
	prof tutorial: MockTutorial lesson: #firstLesson.
	self assert: mockView title equals: 'first (1/3)'.
	self assert: mockView lesson lesson equals: 'First lesson'.! !

TestCase subclass: #SmalltalkSyntaxTutorialTest
	uses: TTutorialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

SmalltalkSyntaxTutorialTest class
	uses: TTutorialTest classTrait
	instanceVariableNames: ''!

!SmalltalkSyntaxTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 12/12/2010 22:20'!
testDivideTwoByZeroSignalsZeroDivide
	[self testedTutorial divideTwoByZero.
	self fail] 
	on: ZeroDivide 
	do: []! !

!SmalltalkSyntaxTutorialTest methodsFor: 'tests' stamp: 'LaurentLaffont 2/1/2010 22:07'!
testEachSelectorExists
	self testedTutorial tutorial do: [:aSelector|
		self assert: (self testedTutorial respondsTo: aSelector) 
	]! !

!SmalltalkSyntaxTutorialTest methodsFor: 'requirements' stamp: 'LaurentLaffont 2/1/2010 22:06'!
testedTutorial
	"Returns an instance of an AbstractTutorial subclass"
	^ SmalltalkSyntaxTutorial new! !

TestCase subclass: #TutorialPlayerTestTutorialAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!TutorialPlayerTestTutorialAccessor methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 21:18'!
testDefaultsToSmalltalkSyntaxTutorial
	| player |
	player := TutorialPlayer new.
	self assert: (player tutorial isKindOf: SmalltalkSyntaxTutorial).! !

!TutorialPlayerTestTutorialAccessor methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 21:19'!
testWithMockTutorial
	| mockTutorial player |
	mockTutorial := MockTutorial new.
	player := TutorialPlayer new tutorial: mockTutorial; yourself.
	self assert: player tutorial equals: mockTutorial.! !

TestCase subclass: #TutorialPlayerTestWithMockTutorial
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!TutorialPlayerTestWithMockTutorial methodsFor: 'running' stamp: 'LaurentLaffont 1/21/2010 20:40'!
setUp
	| tutorial |
	tutorial := MockTutorial new.
	player := TutorialPlayer new tutorial: (MockTutorial new)! !

!TutorialPlayerTestWithMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 20:40'!
testCurrentLessonIsFirstOneAtCreation
	self assert: player currentLesson title equals: 'first'.! !

!TutorialPlayerTestWithMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 20:40'!
testNavigation
	self assert: player next title equals: 'second'.
	self assert: player currentLesson title equals: 'second'.
	
	self assert: player next title equals: 'third'.
	self assert: player currentLesson title equals: 'third'.
	
	self assert: player next title equals: 'third'.
	self assert: player currentLesson title equals: 'third'.
	
	self assert: player previous title equals: 'second'.
	self assert: player currentLesson title equals: 'second'.
	
	self assert: player previous title equals: 'first'.
	self assert: player currentLesson title equals: 'first'.
	
	self assert: player previous title equals: 'first'.
	self assert: player currentLesson title equals: 'first'.! !

!TutorialPlayerTestWithMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 20:43'!
testResetTutorialGoBackToFirstLesson
	player next; next.
	self assert: player currentLesson title equals: 'third'.
	
	player rewind.
	self assert: player currentLesson title equals: 'first'.! !

!TutorialPlayerTestWithMockTutorial methodsFor: 'tests' stamp: 'LaurentLaffont 1/21/2010 20:40'!
testSizeReturnsThree
	self assert: player size equals: 3.! !

AbstractTutorial subclass: #MockTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!MockTutorial methodsFor: 'lesson' stamp: 'LaurentLaffont 1/21/2010 15:15'!
firstLesson
	^ Lesson title: 'first' lesson: 'First lesson'.! !

!MockTutorial methodsFor: 'lesson' stamp: 'LaurentLaffont 1/21/2010 15:15'!
secondLesson
	^ Lesson title: 'second' lesson: 'Second lesson'.! !

!MockTutorial methodsFor: 'lesson' stamp: 'LaurentLaffont 1/21/2010 15:15'!
thirdLesson
	^ Lesson title: 'third' lesson: 'Third lesson'.! !

!MockTutorial methodsFor: 'tutorial' stamp: 'LaurentLaffont 1/21/2010 15:14'!
tutorial 
	^ #(
firstLesson
secondLesson
thirdLesson
)! !

MockTutorial subclass: #MockTutorial2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

Object subclass: #MockLessonView
	instanceVariableNames: 'lesson title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProfStef-Tests'!

!MockLessonView methodsFor: 'accessing' stamp: 'LaurentLaffont 1/21/2010 16:09'!
lesson
	^ lesson! !

!MockLessonView methodsFor: 'gui' stamp: 'LaurentLaffont 1/21/2010 16:10'!
showLesson: aLesson withTitle: aString
	lesson := aLesson.
	title := aString.! !

!MockLessonView methodsFor: 'gui' stamp: 'DannyChan 2/1/2010 22:02'!
showTutorialNode: aTutorialNode
	lesson:= aTutorialNode lessonInstance.
	title := aTutorialNode title.! !

!MockLessonView methodsFor: 'accessing' stamp: 'LaurentLaffont 1/21/2010 16:10'!
title
	^ title! !
